
Redmine - Defect #19398

Failed to get attachment with Chinese filename.

2015-03-16 11:00 - Alan Liu

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:    

Resolution: Duplicate Affected version: 3.0.0

Description

No problem to get attachment with ASCII filename.

Failed to get attachment with Chinese filename. (Internal server error)

Environment:

  Redmine version                3.0.0.stable

  Ruby version                   1.9.3-p545 (2014-02-24) [i386-mingw32]

  Rails version                  4.2.0

  Environment                    production

  Database adapter               Mysql2

SCM:

  Subversion                     1.7.5

  Git                            1.9.5

  Filesystem                     

Redmine plugins:

  redmine_issue_templates        0.1.0

Related issues:

Is duplicate of Redmine - Defect #19374: MinGW thin and puma: Internal server... Closed

History

#1 - 2015-03-16 23:31 - Toshi MARUYAMA

- Status changed from New to Closed

- Resolution set to Duplicate

Duplicate of #19374.

Please contact bitnami team.

#2 - 2015-03-16 23:31 - Toshi MARUYAMA

- Is duplicate of Defect #19374: MinGW thin and puma: Internal server error occoures when attachment file name contains non ASCII added

#3 - 2015-03-17 02:13 - Alan Liu

- Status changed from Closed to Reopened

More background information:

OS: Windows Server 2008 R2 Standard SP1 (Traditional Chinese)

We do not use bitnami package.

The problem is caused after upgrading redmine from 2.6.1 to 3.0.0.

Thanks.

#4 - 2015-03-17 02:55 - Toshi MARUYAMA

- Status changed from Reopened to Closed

I cannot reproduce on Windows 8.1 Pro with webrick (#19374#note-3).

We cannot support individual web server and environment.
#5 - 2015-03-17 10:21 - Alan Liu

It caused by Rails 4.2 (https://github.com/rails/rails/issues/19187 has a workaround, but I don't understand yet).

#6 - 2015-03-17 10:33 - Alan Liu

- Status changed from Closed to Reopened

Indeed, webrick has no problem.

But thin & puma do.

Why? webrick doesn't work with Rails 4.2?

(Sorry, I'm not a ruby programmer)

#7 - 2015-03-17 10:52 - Toshi MARUYAMA

- Status changed from Reopened to Closed

Alan Liu wrote:

It caused by Rails 4.2 (https://github.com/rails/rails/issues/19187 has a workaround, but I don't understand yet).

 It is obvious thin problem.

You should report to thin, not to Rails.

Redmine is Rails app and does not depend on any web server.

We cannot do anything.

#8 - 2015-03-18 03:04 - Alan Liu

The workaround (https://github.com/rails/rails/issues/19187): add some codes in

C:\Ruby193\lib\ruby\gems\1.9.1\gems\actionpack-4.2.0\lib\action_dispatch\middleware\static.rb

          rescue EncodingError

            false

 It will be (from line 31, EncodingError fixes my case)

      if match = paths.detect { |p|

        path = File.join(@root, p)

        begin

          File.file?(path) && File.readable?(path)

          rescue SystemCallError

            false

          rescue EncodingError

            false

        end

      }

#9 - 2015-03-26 14:15 - Toshi MARUYAMA

I have created issue.

https://github.com/macournoyer/thin/issues/268#issuecomment-86508080

#10 - 2015-04-28 04:37 - Alan Liu

- Status changed from Closed to Reopened

The problem comes back after upgrading to 3.0.2 & fixed by adding the same code in

C:\Ruby193\lib\ruby\gems\1.9.1\gems\actionpack-4.2.1\lib\action_dispatch\middleware\static.rb

Environment:

  Redmine version                3.0.2.stable

  Ruby version                   1.9.3-p545 (2014-02-24) [i386-mingw32]

  Rails version                  4.2.1

  Environment                    production

  Database adapter               Mysql2

SCM:

  Subversion                     1.7.5

  Git                            1.9.5

  Filesystem                     

Redmine plugins:

  redmine_issue_templates        0.1.0
#11 - 2015-04-28 06:53 - Toshi MARUYAMA

- Status changed from Reopened to Closed

Rails 4.2.2 will fix.

https://github.com/rails/rails/commit/4df216cb12e35c09ae5ec271755e581d692d0326#diff-6897a0b59abaaa3bbc85da93757c39d9L32

#12 - 2015-04-28 06:57 - Toshi MARUYAMA

You can use Rails 4-2-stable branch to change Gemfile.

-gem "rails", "4.2.1" 

+gem "rails", :github => 'rails/rails', :branch => '4-2-stable'
